//1000,"rapdekl.sci","rapdekl.sci",1.51,SYSTEM
//Copyright (c) Sage sp. z o.o.. Wszelkie prawa zastrzeone.

#include "open.sci"
#include "fkutil.sci"

long iddekl
BASEHANDLE bppPolaZ
#include "infpods.sci"

#ifdef FORTE
int bFirma = OpenBase( KatalogFirmy(), FN_CONFIG + DBFN_EXT, "FDANEADR" )
#else
int bFirma = OpenBase( KatalogFirmy(), FN_CONFIG + DBFN_EXT, "config5" )
#endif
int bDZ = OpenBase( KatalogFirmy(), FN_DEKLZE + DBFN_EXT, "deklzes" )
int bZap = OpenBase( KatalogRoku(), FN_BUF_ZAP + DBFN_EXT, "buf_zapisy" )

int PoleWyliczone, WszystkoWyliczone
int initBrw, initKonto

#ifndef RAPDEKL_NODEKLINFO
DeklaracjaInfo	di
#endif

BrwInfo tBrw(2)
InfoUser		iu
InfoKonta		ik
MapValue mapFields
mapFields.Type(int)

// Ponisze definicje istotnie krtsze od DEKL_TYPE_*
// a to wane w przypadku uycia w formuach.

// typy deklaracji gwnych
#define DT_VAT7		DEKL_TYPE_VAT7
#define DT_VAT7K	DEKL_TYPE_VAT7K
#define DT_VATUE	DEKL_TYPE_VATUE
#define DT_CIT2		DEKL_TYPE_CIT2
#define DT_PIT5		DEKL_TYPE_PIT5
#define DT_PIT5L	DEKL_TYPE_PIT5L
#define DT_VATUEK	DEKL_TYPE_VATUEK
#define DT_VAT7D	DEKL_TYPE_VAT7D

// typy zacznikw do deklaracji
#define DT_VATZZ	DEKL_TYPE_VATZZ
#define DT_VATZT	DEKL_TYPE_VATZT
#define DT_NADZP	DEKL_TYPE_NADZP
#define DT_ORDZU	DEKL_TYPE_ORDZU

#define KPOW	1
#define PPOW	2
#define KPOM	3
#define PPOM	4
#define RKWP	5
#define RKWK	6
#define RKPP	7
#define RKPK	8
#define RKBP	9
#define RKBK	10
//11 to INNE nie uzywane w deklaracjach
#define RKPD	12
#define RKPU	13

record DaneFirmy
	string nazwa[91]
	string skrot[21]
	string wojewodztwo[31]
	string miejscowosc[41]
	string ulica[41]
	string dom[7]
	string lokal[7]
	string kod[7]
	string poczta[41]
	string tel1[16]
	string nip[21]
	string nipUE[21]
	string regon[16]

	int sub CreateRec()
		GetRec(bFirma, FS)
		nazwa = GetField(bFirma, "nazwaPelna")
#ifdef FORTE
		// #31958
		// lub GetField(bCfg, "nazwa")
		skrot = firma.nazwaSkrocona
#else
		skrot = GetField(bFirma, "nazwa")
#endif
		wojewodztwo = GetField(bFirma, "wojewodztwo")
		miejscowosc = GetField(bFirma, "miejscowosc")
		ulica = GetField(bFirma, "ulica")
		dom = GetField(bFirma, "dom")
		lokal = GetField(bFirma, "lokal")
		kod = GetField(bFirma, "kod")
		poczta = GetField(bFirma, "poczta")
		tel1 = GetField(bFirma, "tel1")
		nip = GetField(bFirma, "nip")
		nipUE = GetField(bFirma, "nipUE")
		regon = GetField(bFirma, "regon")
	endsub
endrec

DaneFirmy df
df.CreateRec()

int TypZaokrZlote = Val(GetIni("Deklaracje", "Zaokraglenia"))
if !TypZaokrZlote then
	TypZaokrZlote = 2
	PutIni("Deklaracje", "Zaokraglenia", (using "%d", TypZaokrZlote))
endif

float sub iif(int a_var, float a_true, float a_false)
	if a_var then
		iif = a_true
	else
		iif = a_false
	endif
endsub

string sub iifs(int a_var, string a_true, string a_false)
	if a_var then
		iifs = a_true
	else
		iifs = a_false
	endif
endsub

//==============================================================
//Funkcja ZestRej i funkcje pochodne/pomocnicze 
//==============================================================
int sub GetMcKw(int kw)
	select case kw
	case 1
		GetMcKw = 1
	case 2
		GetMcKw = 4
	case 3
		GetMcKw = 7
	case 4
		GetMcKw = 10
	endselect
endsub

// dla ZestRejHelper i FSEHelper (zgodnie z ext_ksie.hpp)
// ten bit powoduje niewstawianie bdw na list do user interfejsu (ale funkcja i tak przerywa dziaanie i zwraca 0)
#define RAPDEKL_NOMESSAGES 0x100

// dla ZestRejHelper
#define MODE_ZESTREJ 0 //ZestRej/ZestRejExt
#define MODE_ZESTR1 1 //ZestR1
#define MODE_ZESTR2 2 //ZestRej2

// ZestRejHelper to jest funkcja pomocnicza zaimplementowana w C++ (ext_ks2.cpp)
// argument #11 okrela sposb dziaania (uywa MODE_*)
// argument #12 zawiera nazw funkcji uytej w formule deklaracji
// argumenty #13 i #14 powinny by podawane tylko dla MODE_ZESTR2

string rapdeklCaller

// udostpniona dla formu deklaracji
float sub ZestRejExt( int rok, int okr, string sKwota, string stawka, string rZS, string kor, int srTrwale, string abc, int zakres )
	int maxzr = di.bufor
	if !rapdeklCaller then rapdeklCaller = "ZestRejExt"
	int mode = MODE_ZESTREJ
#ifdef RAPDEKL_DEBUG
	mode |= RAPDEKL_NOMESSAGES
#endif
	ZestRejExt = ZestRejHelper( rok, okr, sKwota, stawka, rZS, kor, srTrwale, abc, zakres, maxzr, mode, rapdeklCaller )
	rapdeklCaller = ""
endsub

// udostpniona dla formu deklaracji
float sub ZestRej( string sKwota, string stawka, string rZS, string kor, int srTrwale, string abc, int zakres )
	int rok = di.rok
	int okr = di.okres
	if di.TypDeklaracji == 2 || di.TypDeklaracji == 8 then
		okr = GetMcKw(di.okres)
		if zakres == 1 then zakres = 3
	endif
	if !rapdeklCaller then rapdeklCaller = "ZestRej"
	ZestRej = ZestRejExt( rok, okr, sKwota, stawka, rZS, kor, srTrwale, abc, zakres )
	rapdeklCaller = ""
endsub

// udostpniona dla formu deklaracji
float sub ZestR1( string sKwota, string stawka, string rName, string abc, int zakres )
	int rok = di.rok
	int okr = di.okres
	if di.TypDeklaracji == 2 || di.TypDeklaracji == 8 then
		okr = GetMcKw(di.okres)
		if zakres == 1 then zakres = 3
	endif
	if !rapdeklCaller then rapdeklCaller = "ZestR1"
	int mode = MODE_ZESTR1
#ifdef RAPDEKL_DEBUG
	mode |= RAPDEKL_NOMESSAGES
#endif
	ZestR1 = ZestRejHelper( rok, okr, sKwota, stawka, rName, "", -2, abc, zakres, di.bufor, mode, rapdeklCaller )
	rapdeklCaller = ""
endsub

// od 2010 "patch jesienny" (nowelizacja VAT)
// obsuguje kryteria ze wzgldu na UE i towary/usugi
// udostpniona dla formu deklaracji
float sub ZestRej2( string sKwota, string stawka, string rZS, string kor, int srTrwale, string abc, int zakres, int iUE, int iUsl, string sZs )
	int rok = di.rok
	int okr = di.okres
	if di.TypDeklaracji == 2 || di.TypDeklaracji == 8 then
		okr = GetMcKw(di.okres)
		if zakres == 1 then zakres = 3
	endif
	if !rapdeklCaller then rapdeklCaller = "ZestRej2"
	int mode = MODE_ZESTR2
#ifdef RAPDEKL_DEBUG
	mode |= RAPDEKL_NOMESSAGES
#endif
	ZestRej2 = ZestRejHelper( rok, okr, sKwota, stawka, rZS, kor, srTrwale, abc, zakres, di.bufor, mode, rapdeklCaller, iUE, iUsl, sZs )
	rapdeklCaller = ""
endsub

//==============================================================
//Funkcja PozBrw i funkcje pomocnicze 
//==============================================================
int sub RzymToInt(string rzym)
	select case rzym
    case ""
        RzymToInt = 0
    case "I"
        RzymToInt = 1
    case "II"
        RzymToInt = 2
    case "III"
        RzymToInt = 3
    case "IV"
        RzymToInt = 4
    case "V"
        RzymToInt = 5
    case "VI"
        RzymToInt = 6
    case "VII"
        RzymToInt = 7
    case "VIII"
        RzymToInt = 8
    case "IX"
        RzymToInt = 9
    case "X"
        RzymToInt = 10
    case "XI"
        RzymToInt = 11
    case "XII"
        RzymToInt = 12
    case else
        RzymToInt = 0
	endselect
endsub
//--------------------------------------------------------------
float sub PozBrw( string poz )
BrwInfo brw
int okresObr = Okres(using "%d-%.2d-01", di.rok, di.okres)

if !okresObr then 
	message "Biecy rok nie zawiera podanego okresu.\nNaley wybra waciwy rok i ponowi obliczenia. Ico:!"
	error ""
endif	

int typ, s, poz1, poz2, poz3, parse, iBrw
	if !initBrw	then
		initBrw = 1
		tBrw(1).Oblicz(1, di.NazwaBilansu, di.BRWFlagi)
		tBrw(2).Oblicz(2, di.NazwaRZiS, di.BRWFlagi)
	endif
	buf = poz : if ! find regular "^{*} {*}$" then error using "Niepoprawne okrelenie pozycji: \"%s\"", poz
	select case regular 1
	case "[A]"	
		typ = 1
	case "[P]"
		typ = 2
	case "[S]"
		typ = 3
	case "[Z]"
		typ = 4
	case else
		error using "Niepoprawna strona: \"%s\"", regular 1
	endselect	
	iBrw = iif( typ < 3, 1, 2 )
	tBrw( iBrw ).pozycja( typ, regular 2 )
	PozBrw = tBrw( iBrw ).mc( okresObr )
endsub

//==============================================================
//Funkcje pomocnicze dla Konto
//==============================================================

float sub Konto(string knt, int zakres)
	int koniecOkr, cut = 1, strn = 0
	float strWn, strMa
	string typ

	int okresObr = Okres(using "%d-%.2d-01", di.rok, di.okres)

	if !okresObr then 
		message "Biecy rok nie zawiera podanego okresu.\nNaley wybra waciwy rok i ponowi obliczenia. Ico:!"
		error ""
	endif	
	
	if di.Bufor then ik.bufor = bZap

	knt = Ucase(knt)	

	if Mid(knt, 1, 1) >= "A" then
		typ = Mid(knt, 1, 1)
		cut += 1
	else
		typ = "S"
	endif

	if Mid(knt, 2, 1) >= "A" then 
		if Mid(knt, 2, 1) == "M" then
			strn = 1
		else 
			strn = 0
		endif
		cut += 1
	else
		strn = 0
	endif
	
	knt = Mid(knt, cut)	
		
	ik.Info(knt)

	if ik.podtyp == 1 && typ == "P" then
		ik.PerSaldo()
	else
		ik.Obroty()
	endif
	
	koniecOkr = okresObr + iif(zakres < 2, 0, (zakres - 1))	
	
	strWn = ik.wn.mc(koniecOkr)
	strMa = ik.ma.mc(koniecOkr)
	if zakres && typ != "P" then
		if okresObr > 1 then
			strWn -= ik.wn.mc(okresObr - 1)
			strMa -= ik.ma.mc(okresObr - 1)
		else
			strWn -= ik.wn.bo
			strMa -= ik.ma.bo
		endif
	endif

	select case typ
	case "O"
		Konto = iif(strn, strMa, strWn)
	case "S"
		Konto = iif(strn, strMa - strWn, strWn - strMa)
		if ik.podtyp == 2 then
			// bug #5696 (i wczeniej #1697, le poprawiony)
			if Konto < 0.0 then Konto = 0.0
		endif
	case "P"
		Konto = iif(strn, strMa, strWn)
	case "W"
		Konto = strWn
	case "M"
		Konto = strMa
	endselect
endsub
//--------------------------------------------------------------
float sub CutGrosze(float v)
	buf = using "%f", v
	find regular "{(/-|())([0-9]#)}.{:d#}"
	CutGrosze = Val(regular 1)
endsub
//--------------------------------------------------------------
float sub Pole(int i)
	if i < 1000 then i = (i * 10) + 1000
	if !mapFields.Index((using "%d", i)) then
		PoleWyliczone = 0
		WszystkoWyliczone = 0
	endif		
	Pole = Zaokr(di.GetFloat(i), 2)
endsub
//--------------------------------------------------------------
float sub PoleExt(int i)
	if i < 5000 then i = (i * 10) + 5000
	if !mapFields.Index((using "%d", i)) then
		PoleWyliczone = 0
		WszystkoWyliczone = 0
	endif		
	PoleExt = Zaokr(di.GetFloat(i), 2)
endsub
//--------------------------------------------------------------
float sub Excp(int i)
	if i < 1000 then i = (i * 10) + 1000
	Excp = Zaokr(di.GetExceptionValue(i), 2)
endsub
//--------------------------------------------------------------
float sub ExcpExt(int i)
	if i < 5000 then i = (i * 10) + 5000
	ExcpExt = Zaokr(di.GetExceptionValue(i), 2)
endsub
//--------------------------------------------------------------
float sub Min(float a, float b)
	Min = iif(a < b, a, b)
endsub
//--------------------------------------------------------------
float sub Max(float a, float b)
	Max = iif(a > b, a, b)
endsub
//--------------------------------------------------------------
float sub Zlote(float zl)
	if TypZaokrZlote == 1 then
		Zlote = CutGrosze(zl)
	else
		Zlote = Zaokr(zl, 0)
	endif
endsub
//--------------------------------------------------------------
float sub Oraz(int v1, int v2)
	if v1 && v2 then
		Oraz = 1
	else
		Oraz = 0
	endif	
endsub
//--------------------------------------------------------------
float sub Oraz3(int v1, int v2, int v3)
	if v1 && v2 && v3 then
		Oraz3 = 1
	else
		Oraz3 = 0
	endif	
endsub
//--------------------------------------------------------------
float sub Lub(int v1, int v2)
	if v1 || v2 then
		Lub = 1
	else
		Lub = 0
	endif	
endsub
//--------------------------------------------------------------
float sub Modul(float v)
	if Sign(v) < 0 then
		Modul = v * (-1)
	else
		Modul = v
	endif	
endsub
//--------------------------------------------------------------
string sub LastDayOfMonth(int r, int m)
	DateExt de
	de.StrToDate(using "%d-%.2d-01", r, m)
	de.SetLastDayOfMonth()
	LastDayOfMonth = de.DateToStr()	
endsub
//--------------------------------------------------------------
float sub GetPodatekWgSkali(float v)
	GetPodatekWgSkali = GetPodatek(di.rok, v)
endsub
//--------------------------------------------------------------
float sub PolePopDekl(int nrpola, string strVal)
	int errDZ, errPZ, diffSTAN = -1
	int bDeklKwart = (di.TypDeklaracji == 2 || di.TypDeklaracji == 8)
	int pop = iif(bDeklKwart , 3, 1)
	int mcDekl = iif(bDeklKwart, GetMcKw(di.Okres), di.Okres)
	int rok = iif(mcDekl - pop < 1, di.Rok - 1, di.Rok)
	int mc = iif(mcDekl - pop < 1, 12 + mcDekl - pop , mcDekl - pop)	
	string diffDATAZES, okr, s1, s2

	okr = using "%02d-%02d-01", rok, mc
	if nrpola < 1000 then nrpola = nrpola * 10 + 1000

	int bDZ = OpenBase( KatalogFirmy(), FN_DEKLZE + DBFN_EXT, "DEKLZES" )
	int bPZ = OpenBase( KatalogFirmy(), FN_POLAZE + DBFN_EXT, "POLAZES" )

	SetKey(bDZ, "typ")
	SetKeySeg(bDZ, "typdekl", di.TypDeklaracji)
	SetKeySeg(bDZ, "okres", okr)

	errDZ = GetRec(bDZ, GE)
	while !errDZ && GetField(bDZ, "typdekl") == di.TypDeklaracji && GetField(bDZ, "okres") == okr
		if GetField(bDZ, "stan") > diffSTAN || (GetField(bDZ, "stan") == diffSTAN && GetField(bDZ, "datazes") > diffDATAZES) then
			SetKey(bPZ, "KEY_zes_pole")
			SetKeySeg(bPZ, "idZesDekl", GetField(bDZ, "id"))
			SetKeySeg(bPZ, "nrpola", 1010)
			errPZ = GetRec(bPZ, EQ)
			if !errPZ then
				s1 = GetField(bPZ, "valString")
				s2 = di.GetString(1010)
				// #28521 zmiana NIP od czasu poprzedniej deklaracji powoduje e kwota si nie przenosi.
				if s1 == s2 then
					SetKeySeg(bPZ, "idZesDekl", GetField(bDZ, "id"))
					SetKeySeg(bPZ, "nrpola", nrpola)
					errPZ = GetRec(bPZ, EQ)					 						
					if !errPZ then
						PolePopDekl = GetField(bPZ, strVal)
						diffSTAN = GetField(bDZ, "stan")  
						diffDATAZES = GetField(bDZ, "datazes")
					endif
				endif
			endif
		endif
		errDZ = GetRec(bDZ, NX)
	wend
	close bDZ : close bPZ
endsub
//--------------------------------------------------------------
float sub PoleDekl(int nrpola)
	if nrpola < 1000 then nrpola = nrpola * 10 + 1000
	int bPZ = OpenBase( KatalogFirmy(), FN_POLAZE + DBFN_EXT, "POLAZES" )

	SetKey(bPZ, "KEY_zes_pole")
	SetKeySeg(bPZ, "idZesDekl", di.parentDeklZes)
	SetKeySeg(bPZ, "nrpola", nrpola)

	if !GetRec(bPZ, EQ) then PoleDekl = GetField(bPZ, "valKwota")

	close bPZ
endsub
//--------------------------------------------------------------
float sub KwotaPopDekl(int nrpola)
	KwotaPopDekl = PolePopDekl(nrpola, "valKwota")
endsub
//--------------------------------------------------------------
int sub CheckPopDekl(int nrpola)
	CheckPopDekl = PolePopDekl(nrpola, "valCheck")
endsub
//--------------------------------------------------------------
int sub IntPopDekl(int nrpola)
	IntPopDekl = PolePopDekl(nrpola, "valInt")
endsub
//--------------------------------------------------------------
string sub GetKodUS(int nr)
	if nr < 1000 then nr = (nr * 10) + 1000
	dispatch xUr = xFactory.NewObject("BUr")
	dispatch xParams = xUr.Params()

	xParams.nazwa = di.GetString(nr)
	xUr.Load(xParams)

	if xUr.Count() > 0 && xUr.item(1).nazwa == di.GetString(nr) then GetKodUS = xUr.item(1).kodUS

	if len(GetKodUS) != 4 then GetKodUS = di.GetString(nr+1)
endsub	
//--------------------------------------------------------------

//==============================================================
//Funkcja FSE (obsuga wyjtkw)
//==============================================================

// FSEHelper to jest funkcja pomocnicza
// przedostatni argument okrela sposb dziaania:
// RAPDEKL_NOMESSAGES - ten bit powoduje niewstawianie bdw na list (ale funkcja i tak przerywa dziaanie i zwraca 0)
// ostatni argument zawiera nazw funkcji uytej w formule deklaracji

float sub FSE( int kategoria )
	int rok = di.rok
	int okr = di.okres
	int nar = di.narastajaco
	int maxzr = di.bufor
	if !rapdeklCaller then rapdeklCaller = "FSE"
	int mode = 0
#ifdef RAPDEKL_DEBUG
	mode |= RAPDEKL_NOMESSAGES
#endif
	FSE = FSEHelper( rok, okr, kategoria, nar, maxzr, mode, rapdeklCaller )
	rapdeklCaller = ""
endsub

string RAPDEKL_PK, RAPDEKL_KK

void sub rapdeklWyliczDatyOkresu()
	int pk
	if !RAPDEKL_PK || !RAPDEKL_KK then
		if di.Kwartalna then
			pk = dateutilPoczatekKwartalu( di.okres )
			RAPDEKL_PK = dateutilDataRMD( di.rok, pk, 1 )
			RAPDEKL_KK = dateutilDataRMD( di.rok, 2 + pk, dateutilOstatniDzien( di.rok, 2 + pk ) )
		else
			RAPDEKL_PK = dateutilDataRMD( di.rok, di.okres, 1 )
			RAPDEKL_KK = dateutilDataRMD( di.rok, di.okres, dateutilOstatniDzien( di.rok, di.okres ) )
		endif
	endif
endsub

// #9653 wyliczamy domyln warto pola numer zgodnie z wpisem w workitemie
// zmiana algorytmu stosownie do #20593
string sub VATUEK_Numer()
	rapdeklWyliczDatyOkresu()

	int err, iQ, iQKwart, iZal
	long ZesDekl_id, ZesDekl_iddekl
	bool wKwart

	setKey( bDZ, "typ" )
	setKeySeg( bDZ, "typdekl", di.TypDeklaracji )
	setKeySeg( bDZ, "okres", RAPDEKL_KK )
	err = GetRec( bDZ, LE )
	ZesDekl_id = 0
	while !err && !ZesDekl_id && ( getField( bDZ, "typdekl" ) == di.typDeklaracji )
		if 1 == getField( bDZ, "stan" ) then
			// zatwierdzona
			ZesDekl_iddekl = getField( bDZ, "iddekl" )
			ZesDekl_id = getField( bDZ, "id" )
			if getField( bDZ, "okres" ) >= RAPDEKL_PK then
				wKwart = true
			else
				wKwart = false
			endif
		endif
		if !err && !ZesDekl_id then
			err = getRec( bDZ, PR )
		endif
	wend

	// jedynki s a konto niniejszej deklaracji
	// poniej uwzgldniam liczb zacznikw z poprzedniej deklaracji
	iQ = iQKwart = 1
	string sR1, sR2
	long wntC, wdtC, wduC
	int deklWzor
	BASEHANDLE bDekl
	if ZesDekl_id then
		bppPolaZ = dbOpen( "polazes", true )
		bDekl = dbOpen( "dekl", true )
		if bppPolaZ && bDekl then
			setKey( bDekl, "idx" )
			setKeySeg( bDekl, "idx", ZesDekl_iddekl )
			if !getRec( bDekl, EQ ) then
				deklWzor = val( getField( bDekl, "wzor" ) )
				setKey( bppPolaZ, "KEY_zes_pole" )
				setKeySeg( bppPolaZ, "idZesDekl", ZesDekl_id )
				setKeySeg( bppPolaZ, "nrpola", VATUEK_GetNrPolaZal( deklWzor ) )
				if !getRec( bppPolaZ, EQ ) then
					buf = getField( bppPolaZ, "valString" )
					if find regular "^{*}//{*}$" then
						iddekl = ZesDekl_id
						wntC = InfPods_WNT_Count()
						wdtC = InfPods_WDT_Count()
						wduC = InfPods_WDU_Count()
						iZal = VATUEK_GetZalCount( deklWzor, wntC, wdtC, wduC )
						if wKwart then
							sR1 = regular 1
							iQKwart += ( val( sR1 ) - 1 + iZal ) // -1 bo zaaczniki poniej dodaj
						endif
						sR2 = regular 2
						iQ += ( val( sR2 ) - 1 + iZal ) // -1 bo zaaczniki poniej dodaj
					endif
				endif
			endif
		endif
		if bppPolaZ then dbClose( bppPolaZ )
		if bDekl then dbClose( bDekl )
	endif

	VATUEK_Numer = using "%d/%d", iQKwart, iQ
endsub
