//1000,"epitpom.sci","Dane deklaracji",1.08,SYSTEM
//Copyright (c) Sage sp. z o.o.. Wszelkie prawa zastrzeone.

#include "dbutil.sci"

idde = Val(Arg1)

int bppPolaZ
if idde then
	bppPolaZ = DbOpen( "polazes", 1 )
	SetKey( bppPolaZ, "KEY_zes_pole" ) // robocze
endif

// to musi odpowiada temu co robi Daniel
#define PPNRPOLABASE_STD 1000
#define PPNRPOLABASE_ALT 5000 // dla CIT2O
long ppNrPolaBase = PPNRPOLABASE_STD

long sub ppNrPola( long nrpola )
	if nrpola < ppNrPolaBase then
		ppNrPola = nrpola * 10 + ppNrPolaBase
	else
		ppNrPola = nrpola
	endif
endsub

long iddekl = val( arg1 )
#include "deklzes.sci"

long idDeklForTyp = 0
long typDekl
BASEHANDLE bppPolaD = 0
string sub PitPoleStr( long nrPola )
	BTERRORTYPE ePD
	if !bppPolaD then
		bppPolaD = dbOpen( "poladekl", true )
		if !bppPolaD then error "getPitPoleStr dbOpen"
		setKey( bppPolaD, "KEY_pola_dekl" )
	endif
	if iddekl != idDeklForTyp then
		idDeklForTyp = iddekl
		typDekl = deklZesTyp()
	endif
	setKeySeg( bppPolaD, "iddekl", typDekl )
	setKeySeg( bppPolaD, "nrpola", nrpola )
	ePD = getRec( bppPolaD, EQ )

	bool bAux = false
	bool bErr = false 
	select case ePD
	case 0
		// DEKL_TYP_NOTATKA 12
		if 12 == getField( bppPolaD, "typ" ) then
			bAux = true
		endif
	case BE_KEYNOTFOUND
		if 10000000 > nrPola then
			bErr = true
		endif
		// W przeciwnym razie jest to pole VAT-UE/VAT-UEK, ktrego definicji nie ma
		// Do takich pl nie stosuje si auxText
	case else
		bErr = true
	endselect

	if bErr then
		error using "getPitPoleStr( %l ) getRec error %l; iddekl = %l", nrPola, ePD, typDekl
	endif

	if bAux then
		PitPoleStr = getAuxText( 1, BFI_POLAZES, iddekl, nrPola )
	else
		PitPoleStr = getField( bppPolaZ, "valString" )
	endif
endsub

string sub PitPole(string nrpola, int typpola, int wymagane)
	int mask, iRegular2 = 1
	long nr = 0, nrp
	string sRegular2
	nrpola = ucase(nrpola)
	buf = nrpola
	if (Find regular at "^E/-{:d}$") || (Find regular at "^E/-{:d:d}$") || (Find regular at "^E/-{:d}{:c}$") || (Find regular at "^E/-{:d:d}{:c}$")then
		if regular 2 then
			sRegular2 = regular 2
			iRegular2 = sRegular2(1) - 'A' + 1
		endif
		nr = (val(regular 1) * 10) + 1000 + iRegular2
	else
		nr = val(nrpola)
	endif

	if idde then
		SetKeySeg(bppPolaZ, "idZesDekl", idde)
		SetKeySeg(bppPolaZ, "nrpola", nrp = ppNrPola(nr))
		if GetRec(bppPolaZ, EQ) then PitPole = "" : exit
		select case typpola
		case TYPPOLA_Kwota
			if GetField(bppPolaZ, "valKwota") != 0.0 || wymagane then PitPole = using "%.2f", GetField(bppPolaZ, "valKwota")
		case TYPPOLA_KwotaZaokr
			if GetField(bppPolaZ, "valKwota") != 0.0 || wymagane then PitPole = using "%.0f", GetField(bppPolaZ, "valKwota")
		case TYPPOLA_Tekst
			PitPole = PitPoleStr( nrp )
		case TYPPOLA_Data
			PitPole = GetField(bppPolaZ, "valData")
		case TYPPOLA_Wybor
			mask = GetField(bppPolaZ, "valCheck")
			if (mask & 1) then PitPole = "1"
			if (mask & 2) then PitPole = "2"
			if (mask & 4) then PitPole = "3"
			if (mask & 8) then PitPole = "4"
		case TYPPOLA_Wybor1
			mask = GetField(bppPolaZ, "valCheck")
			if (mask & 1) then PitPole = "1"
		case TYPPOLA_Liczba
			if GetField(bppPolaZ, "valInt") != 0  || wymagane then PitPole = using "%d", GetField(bppPolaZ, "valInt")
		case else
			error "PitPole: nieznany typ pola"
		endselect
	else
		PitPole = "PitPole: !iddekl"
	endif
endsub

string sub PitPoleNr(long nr, int typpola, int wymagane)
	string nrpola = using "%l", nr
	PitPoleNr = PitPole(nrpola, typpola, wymagane)
endsub
	
string sub KatalogXsl()
	KatalogXsl = Katalog() + "Raporty\\Template\\XSL\\"
endsub

string sub PitKodUrzedu(int nr)
	if nr < 1000 then nr = (nr * 10) + 1001
	PitKodUrzedu = PitPole((using "%d", nr), TYPPOLA_Tekst, 0)
endsub

int sub XmlPitListaUE(int typ)
	long iPole	
	select case typ
		case TYPUE_WDT
			iPole = 10000000
		case TYPUE_WNT
			iPole = 20000000
		case TYPUE_WSU
			iPole = 30000000						
	endselect

	string sGrupa = using "Grupa%d", typ
	string checkTT

	while PitPoleNr(iPole, TYPPOLA_Tekst, 0)
		checkTT = "1"
		E_deklaracja.BeginElement(sGrupa)
		E_Deklaracja.AddValueNr(PitPoleNr(iPole, TYPPOLA_Tekst, 0), 100)
		E_Deklaracja.AddValueNr(PitPoleNr(iPole + 1, TYPPOLA_Tekst, 0), 101)
		E_Deklaracja.AddValueNr(PitPoleNr(iPole + 2, TYPPOLA_KwotaZaokr, 1), 102)
		
		if typ != TYPUE_WSU then
			if PitPoleNr(iPole + 3, TYPPOLA_Wybor, 0) == "1" then checkTT = "2"
			E_Deklaracja.AddValueNr(checkTT, 103)
		endif	

		E_deklaracja.EndElement(sGrupa)
		iPole += 10		
	wend
endsub

int sub XmlPitListaUEK(int typ)
	long iPole	
	select case typ
		case TYPUE_WDT
			iPole = 10000000
		case TYPUE_WNT
			iPole = 20000000
		case TYPUE_WSU
			iPole = 30000000						
	endselect
	
	string sGrupa = using "Grupa%d", typ
	string checkTT

	// #26647
	// 1242 jak w dekl.sci
	// patrz te PokazDaneKth: kwota <> 0 to pokazujemy
	// w wersji XML, pomijamy wszystkie elementy "BYO"
	bool bBylo = ( 1 == val( PitPoleNr( 1242, TYPPOLA_Wybor, 0 ) ) )
	bool bZero
	string sVal
	string sKw

	while PitPoleNr(iPole, TYPPOLA_Tekst, 0)
		sKw = PitPoleNr( iPole + 4, TYPPOLA_KwotaZaokr, 1 )
		bZero = !Sign( val( sKw ) )

		if PitPoleNr( iPole + 3, TYPPOLA_Wybor, 0 ) == "1" then
			checkTT = "2"
		else
			checkTT = "1"
		endif

		E_deklaracja.BeginElement(sGrupa)

		if bBylo || !bZero then
			sVal = PitPoleNr( iPole, TYPPOLA_Tekst, 0 )
			E_Deklaracja.AddValueNr( sVal, 100 )

			sVal = PitPoleNr( iPole + 1, TYPPOLA_Tekst, 0 )
			E_Deklaracja.AddValueNr( sVal, 101 )

			E_Deklaracja.AddValueNr( sKw, 102 )

			if typ != TYPUE_WSU then
				E_Deklaracja.AddValueNr( checkTT, 103 )
			endif
		endif

		E_Deklaracja.AddValueNr(PitPoleNr(iPole, TYPPOLA_Tekst, 0), 104)
		E_Deklaracja.AddValueNr(PitPoleNr(iPole + 1, TYPPOLA_Tekst, 0), 105)
		E_Deklaracja.AddValueNr(PitPoleNr(iPole + 2, TYPPOLA_KwotaZaokr, 1), 106)
		
		if typ != TYPUE_WSU then
			E_Deklaracja.AddValueNr(checkTT, 107)
		endif
		
		E_deklaracja.EndElement(sGrupa)
		
		iPole += 10		
	wend
endsub

int sub KatalogXml()
	filede = Arg2
	print "zapisano eDeklaracj w lokalizacji:\n" + Arg2
endsub

KatalogXml()

#include "deklzal.sci"
